#include "Stones.inc"
#include "sqrDohNut.inc"
#include "knot.inc"           
#include "tuber.inc"
                            
#declare T_Stone1 =
texture
{
  pigment
  {  
    bozo
    pigment_map
    {
       [ 0 color Gray15]
       [ .1 color Gray80] 
       [ .7 Black]
       [1 color Black]
    }
  }  
  scale 0.15
}
texture{T_Grnt11a scale <3, 6, 2> rotate <0, 0, 50>}
texture{T_Grnt19a scale <1, 2, 1> rotate <0, 0, -50>
finish{phong 1 phong_size 90}
}

#declare T_Stone3 =
texture
{
  pigment
  {  
    bozo
    pigment_map
    {
       [0 color Gray05]
       [.1 color Gray30] 
       [.6 color Black]
       [1 color Black]
    }
  }  
  scale 0.15
}
texture{T_Grnt11a scale <3, 6, 2> rotate <0, 0, 50>}
texture{T_Grnt19a scale <1, 2, 1> rotate <0, 0, -50>
}


#declare Edging =
union
{
  #declare Y=3.3955;
  #declare Z=-9.6835;
  #declare X=.6065;
  
  union
  {           
    cylinder{<-X+.1,0,0>,<+X-.1,0,0>,.05}
    
    object
    {
      intersection{torus{.1,.05}box{ <0,-5,0>,<5,5,5> }} 
      rotate -90*x 
      translate <X-.1,-.1,0>
    }    
    
    object
    {
      intersection{torus{.1,.05}box{ <0,-5,0>,<5,5,5> }} 
      rotate -90*x 
      rotate 90*z
      translate <-X+.1,-.1,0>
    }
    object
    {
      tripleArc(13,2,-90,
                16,2,0,
                20,8,0,
                .05)
      rotate 90*x
      translate <X,-.1,0>      
    }
    object
    {
      tripleArc(13,2,-90,
                16,2,0,
                20,8,0,
                .05)
      rotate 90*x
      translate <-X,-.1,0>      
    }
    rotate 10*x
    translate<0,Y,Z>     
  }       
  
  
}

#declare TopStone =
union
{  
  difference
  {
    superellipsoid
    {
      <.1,1>
      rotate 90*x
      scale <1,5,1>
      translate -9*z  
    } 
    object
    {
      roundBox(1.2,2.8,1,.1)     
      texture{T_Stone3 scale 1/6}
      translate <0,2,-10.125>
    }
  } 
                                
  object{ crossknot translate<-1.8,3,0> scale .25  translate<-.05,0,-9.625>}      

}
    
#declare Stone=
union
{
  object { TopStone }
  
  intersection
  {
    object { Edging }
    object
    {
      roundBox(1.2,2.8,1,.1)
      translate <0,2,-10.125>
    }
    superellipsoid
    {
      <.1,1>
      rotate 90*x
      scale <1,5,1>
      translate -9*z  
    } 
  }
  // top step

  difference
  {
    roundBox(3,1,3,0.1)
    #declare ww=1.05; 
    box{<-ww,-2,-ww>,<ww,2,ww>}
    translate -9*z  
    texture{T_Stone1 scale 1/6}
    normal{ bumps bump_size 1 scale 1/24}    
  } 
  
  object
  {
    sqrDohNutLWRr(1.95,1.95,.1,.1)  
    rotate 90*x
    translate .4*y
    translate -9*z
    texture{T_Stone1 scale 1/6}
    normal{ bumps bump_size 1 scale 1/24}    
  }

  translate 9*z
  scale 6
  translate -4*y
  texture{T_Stone1} 
  normal{ granite scale 5}
  rotate -20*y
}